using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using EPSCOMLib;
using Microsoft.DirectX;
using Microsoft.DirectX.DirectSound;
using Microsoft.DirectX.AudioVideoPlayback;

namespace EPS_A4
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.PictureBox pictureBox3;
		private System.Windows.Forms.PictureBox pictureBox4;
		private System.Windows.Forms.PictureBox pictureBox5;
		private System.Windows.Forms.PictureBox pictureBox6;
		private System.Windows.Forms.PictureBox pictureBox1;

		const int MIN_VOLUME = -2500;
		const int MAX_VOLUME = 0;

		private Device m_SoundDevice;
		private Microsoft.DirectX.DirectSound.Buffer[] sounds = new Microsoft.DirectX.DirectSound.Buffer[18];

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private EPSLens lens;
		private EPSLensRegion region; 
		bool WeAreDrawing = false;
		bool inBirds = true;
		bool inAmphib = false;
		bool inInsects = false;

		PictureBox[] items = new PictureBox[6];
		int[] OrigX = new int[6];
		int[] OrigY = new int[6];
		int[] OrigW = new int[6];
		int[] OrigH = new int[6];
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;

		String[] labels = new String[6];

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_SoundDevice = new Device();
			m_SoundDevice.SetCooperativeLevel(this, CooperativeLevel.Priority);

			BufferDescription bd = new BufferDescription();
			bd.ControlVolume = true;
			bd.GlobalFocus = true;

			//Bird Sounds
			sounds[0] = new SecondaryBuffer("little_tinamous.wav", bd, m_SoundDevice);
			sounds[1] = new SecondaryBuffer("Northern Jacana.wav", bd, m_SoundDevice);
			sounds[2] = new SecondaryBuffer("keel billed toucan.wav", bd, m_SoundDevice);
			sounds[3] = new SecondaryBuffer("Blue crowned Motmot.wav", bd, m_SoundDevice);
			sounds[4] = new SecondaryBuffer("steely vented hummingbird.wav", bd, m_SoundDevice);
			sounds[5] = new SecondaryBuffer("pauraque.wav", bd, m_SoundDevice);

			//Amphibian Sounds
			sounds[6] = new SecondaryBuffer("Pacific Chorus Frog.wav", bd, m_SoundDevice);
			sounds[7] = new SecondaryBuffer("Boreal Chorus Frog.wav", bd, m_SoundDevice);
			sounds[8] = new SecondaryBuffer("Pacific Treefrog.wav", bd, m_SoundDevice);
			sounds[9] = new SecondaryBuffer("Woodhouse's Toad.wav", bd, m_SoundDevice);
			sounds[10] = new SecondaryBuffer("Bullfrog.wav", bd, m_SoundDevice);
			sounds[11] = new SecondaryBuffer("Western Rattlesnake.wav", bd, m_SoundDevice);

			//Insect Sounds
			sounds[12] = new SecondaryBuffer("Field Cricket.wav", bd, m_SoundDevice);
			sounds[13] = new SecondaryBuffer("Acridid Grasshopper.wav", bd, m_SoundDevice);
			sounds[14] = new SecondaryBuffer("Pallid-winged Grasshopper.wav", bd, m_SoundDevice);
			sounds[15] = new SecondaryBuffer("Red-Winged Grasshopper.wav", bd, m_SoundDevice);
			sounds[16] = new SecondaryBuffer("Cicada.wav", bd, m_SoundDevice);
			sounds[17] = new SecondaryBuffer("Tree Cricket.wav", bd, m_SoundDevice);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.pictureBox3 = new System.Windows.Forms.PictureBox();
			this.pictureBox4 = new System.Windows.Forms.PictureBox();
			this.pictureBox5 = new System.Windows.Forms.PictureBox();
			this.pictureBox6 = new System.Windows.Forms.PictureBox();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(352, 408);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(88, 72);
			this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox2.TabIndex = 1;
			this.pictureBox2.TabStop = false;
			this.pictureBox2.Click += new System.EventHandler(this.pictureBox2_Click);
			this.pictureBox2.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox2_MouseMove);
			// 
			// pictureBox3
			// 
			this.pictureBox3.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox3.Image")));
			this.pictureBox3.Location = new System.Drawing.Point(568, 80);
			this.pictureBox3.Name = "pictureBox3";
			this.pictureBox3.Size = new System.Drawing.Size(88, 80);
			this.pictureBox3.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox3.TabIndex = 2;
			this.pictureBox3.TabStop = false;
			this.pictureBox3.Click += new System.EventHandler(this.pictureBox3_Click);
			this.pictureBox3.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox3_MouseMove);
			// 
			// pictureBox4
			// 
			this.pictureBox4.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox4.Image")));
			this.pictureBox4.Location = new System.Drawing.Point(568, 240);
			this.pictureBox4.Name = "pictureBox4";
			this.pictureBox4.Size = new System.Drawing.Size(88, 80);
			this.pictureBox4.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox4.TabIndex = 3;
			this.pictureBox4.TabStop = false;
			this.pictureBox4.Click += new System.EventHandler(this.pictureBox4_Click);
			this.pictureBox4.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox4_MouseMove);
			// 
			// pictureBox5
			// 
			this.pictureBox5.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox5.Image")));
			this.pictureBox5.Location = new System.Drawing.Point(344, 80);
			this.pictureBox5.Name = "pictureBox5";
			this.pictureBox5.Size = new System.Drawing.Size(88, 72);
			this.pictureBox5.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox5.TabIndex = 4;
			this.pictureBox5.TabStop = false;
			this.pictureBox5.Click += new System.EventHandler(this.pictureBox5_Click);
			this.pictureBox5.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox5_MouseMove);
			// 
			// pictureBox6
			// 
			this.pictureBox6.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox6.Image")));
			this.pictureBox6.Location = new System.Drawing.Point(344, 240);
			this.pictureBox6.Name = "pictureBox6";
			this.pictureBox6.Size = new System.Drawing.Size(88, 72);
			this.pictureBox6.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox6.TabIndex = 5;
			this.pictureBox6.TabStop = false;
			this.pictureBox6.Click += new System.EventHandler(this.pictureBox6_Click);
			this.pictureBox6.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox6_MouseMove);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(576, 408);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(88, 72);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 6;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Click += new System.EventHandler(this.pictureBox1_Click);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.DarkSeaGreen;
			this.groupBox1.Controls.Add(this.button3);
			this.groupBox1.Controls.Add(this.button2);
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(200, 560);
			this.groupBox1.TabIndex = 7;
			this.groupBox1.TabStop = false;
			// 
			// button1
			// 
			this.button1.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.Location = new System.Drawing.Point(32, 136);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(120, 48);
			this.button1.TabIndex = 0;
			this.button1.Text = "BIRDS";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.Location = new System.Drawing.Point(32, 248);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(120, 48);
			this.button2.TabIndex = 1;
			this.button2.Text = "AMIPHIBIANS AND REPTILES";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button3.Location = new System.Drawing.Point(32, 376);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(120, 48);
			this.button3.TabIndex = 2;
			this.button3.Text = "INSECTS";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.SeaGreen;
			this.ClientSize = new System.Drawing.Size(792, 566);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.pictureBox6);
			this.Controls.Add(this.pictureBox5);
			this.Controls.Add(this.pictureBox4);
			this.Controls.Add(this.pictureBox3);
			this.Controls.Add(this.pictureBox2);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseMove);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void SetupEPS () 
		{
			// Create a new lens 
			lens = new EPSLensClass();      
			lens.RemoveAllRegions();    

			// Create a region and add it to the lens
			region = new EPSLensRegionClass();  
			lens.AddRegion(region);


			lens.Shape = EPSCOMLib.epsFocusShapes.epsShape_Circle;
			region.DropoffFunction = epsDropoffFunctions.epsDropoff_Linear;
			region.DropoffWidth = 100.0f;
			lens.Magnification = 3;
		}

		private void SetupPictures ()
		{
			items[0] = pictureBox1;
			items[1] = pictureBox2;
			items[2] = pictureBox3;
			items[3] = pictureBox4;
			items[4] = pictureBox5;
			items[5] = pictureBox6;

			for(int i = 0; i<6; i++) 
			{
				OrigX[i] = items[i].Left;
				OrigY[i] = items[i].Top;
				OrigW[i] = items[i].Width;
				OrigH[i] = items[i].Height;
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.SetupEPS();
			this.SetupPictures();
			this.loadBirds();
		}

		private void Draw()
		{
			float mag;
			Graphics gfx; 
			Pen p = new Pen(Color.White);
			p.Width = 2;
			Font nf; 
			if(!WeAreDrawing)
			{ 
				WeAreDrawing = true;

				EPSVec2 vecIn = new EPSVec2Class();
				EPSVec2 vecOut = new EPSVec2Class();

				for(int i=0; i<6; i++)
				{
					vecIn.set(OrigX[i] + OrigW[i] / 2, OrigY[i] + OrigH[i] / 2); 
					vecOut = lens.get_MagnifiedPoint2D(vecIn);
					mag = lens.get_MagnificationAmount(vecIn);

					Rectangle newbounds = new Rectangle(0, 0, (int)(OrigW[i] * mag), (int)(OrigH[i] * mag));
					

					newbounds.Location = new Point( (int) (vecIn.x - ( newbounds.Width / 2)), (int) (vecIn.y - ( newbounds.Height / 2 )) );
					items[i].Bounds = newbounds;

					nf = new Font("Microsoft Sans Serif", 5*(mag * 1.75f));
					gfx = items[i].CreateGraphics();
					if(mag >2.8)
					{
						gfx.DrawString(labels[i],nf,Brushes.White,0,0);
					}

					
				}
			}
			WeAreDrawing = false;
		}

		private void Form1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			EPSVec2 focalCenter = new EPSVec2Class();
			focalCenter.set(e.X, e.Y);
			lens.Center = focalCenter;
			Draw();
			
			
		}

		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			PictureBox picture = (PictureBox)sender; 
			System.Windows.Forms.MouseEventArgs m = new System.Windows.Forms.MouseEventArgs(e.Button, e.Clicks, e.X + picture.Left, e.Y + picture.Top, e.Delta);
			Form1_MouseMove(sender, m);

			for(int i=0; i<18; i++)
			{
				sounds[i].Volume = MIN_VOLUME;
			}

			if(this.inBirds)
			{
				sounds[0].Volume = 0;
			}
			else if(this.inAmphib)
			{
				sounds[6].Volume = 0;
			}
			else if(this.inInsects)
			{
				sounds[12].Volume = 0;
			}
		}


		private void pictureBox2_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			PictureBox picture = (PictureBox)sender; 
			System.Windows.Forms.MouseEventArgs m = new System.Windows.Forms.MouseEventArgs(e.Button, e.Clicks, e.X + picture.Left, e.Y + picture.Top, e.Delta);
			Form1_MouseMove(sender, m);

			
			for(int i=0; i<18; i++)
			{
				sounds[i].Volume = MIN_VOLUME;
			}

			if(this.inBirds)
			{
				sounds[1].Volume = 0;
			}
			else if(this.inAmphib)
			{
				sounds[7].Volume = 0;
			}
			else if(this.inInsects)
			{
				sounds[13].Volume = 0;
			}
		}

		private void pictureBox3_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			PictureBox picture = (PictureBox)sender; 
			System.Windows.Forms.MouseEventArgs m = new System.Windows.Forms.MouseEventArgs(e.Button, e.Clicks, e.X + picture.Left, e.Y + picture.Top, e.Delta);
			Form1_MouseMove(sender, m);

			for(int i=0; i<18; i++)
			{
				sounds[i].Volume = MIN_VOLUME;
			}

			if(this.inBirds)
			{
				sounds[2].Volume = 0;
			}
			else if(this.inAmphib)
			{
				sounds[8].Volume = 0;
			}
			else if(this.inInsects)
			{
				sounds[14].Volume = 0;
			}
		}

		private void pictureBox4_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			PictureBox picture = (PictureBox)sender; 
			System.Windows.Forms.MouseEventArgs m = new System.Windows.Forms.MouseEventArgs(e.Button, e.Clicks, e.X + picture.Left, e.Y + picture.Top, e.Delta);
			Form1_MouseMove(sender, m);

			for(int i=0; i<18; i++)
			{
				sounds[i].Volume = MIN_VOLUME;
			}

			if(this.inBirds)
			{
				sounds[3].Volume = 0;
			}
			else if(this.inAmphib)
			{
				sounds[9].Volume = 0;
			}
			else if(this.inInsects)
			{
				sounds[15].Volume = 0;
			}
		}

		private void pictureBox5_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			PictureBox picture = (PictureBox)sender; 
			System.Windows.Forms.MouseEventArgs m = new System.Windows.Forms.MouseEventArgs(e.Button, e.Clicks, e.X + picture.Left, e.Y + picture.Top, e.Delta);
			Form1_MouseMove(sender, m);

			
			for(int i=0; i<18; i++)
			{
				sounds[i].Volume = MIN_VOLUME;
			}


			if(this.inBirds)
			{
				sounds[4].Volume = 0;
			}
			else if(this.inAmphib)
			{
				sounds[10].Volume = 0;
			}
			else if(this.inInsects)
			{
				sounds[16].Volume = 0;
			}
		}

		private void pictureBox6_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			PictureBox picture = (PictureBox)sender; 
			System.Windows.Forms.MouseEventArgs m = new System.Windows.Forms.MouseEventArgs(e.Button, e.Clicks, e.X + picture.Left, e.Y + picture.Top, e.Delta);
			Form1_MouseMove(sender, m);
			
			for(int i=0; i<18; i++)
			{
				sounds[i].Volume = MIN_VOLUME;
			}


			if(this.inBirds)
			{
				sounds[5].Volume = 0;
			}
			else if(this.inAmphib)
			{
				sounds[11].Volume = 0;
			}
			else if(this.inInsects)
			{
				sounds[17].Volume = 0;
			}

		}

		private void loadBirds()
		{
			inBirds = true;
			inAmphib = false;
			inInsects = false;

			pictureBox1.Image = Image.FromFile("littleTinamou.jpg");
			pictureBox2.Image = Image.FromFile("Northern-Jacana.jpg");
			pictureBox3.Image = Image.FromFile("Keel-billedToucan.jpg");
			pictureBox4.Image = Image.FromFile("Blue-Crowned-Motmot.jpg");
			pictureBox5.Image = Image.FromFile("Steely-vented Hummingbird.jpg");
			pictureBox6.Image = Image.FromFile("Paraque.jpg");

			labels[0] = "Little Tinamous";
			labels[1] = "Northern Jacana";
			labels[2] = "Keel Billed\nToucan";
			labels[3] = "Blue Crowned\nMotmot";
			labels[4] = "Steely Vented\nHummingbird";
			labels[5] = "Pauraque";

			for(int i=0; i<6; i++)
			{
				sounds[i].Play(0, BufferPlayFlags.Looping);
				sounds[i].Volume = MIN_VOLUME;
			}

			for(int i=6; i<18; i++)
			{
				sounds[i].Stop();
			}
		}

		private void loadAmphib()
		{
			inBirds = false;
			inAmphib =  true;
			inInsects = false;

			pictureBox1.Image = Image.FromFile("Pacific_chorus_frog.jpg");
			pictureBox2.Image = Image.FromFile("chorusfrog.jpg");
			pictureBox3.Image = Image.FromFile("Pacific_treefrog.jpg");
			pictureBox4.Image = Image.FromFile("Woodhous's_Toad.jpg");
			pictureBox5.Image = Image.FromFile("bullfrog.jpg");
			pictureBox6.Image = Image.FromFile("diamondback.jpg");

			labels[0] = "Pacific Chorus\nFrog";
			labels[1] = "Boreal Chorus\nFrog";
			labels[2] = "Pacific Treefrog";
			labels[3] = "Woodhouse's\nToad";
			labels[4] = "Bullfrog";
			labels[5] = "Diamondback\nRattlesnake";

			for(int i=0; i<6; i++)
			{
				sounds[i].Stop();
			}

			for(int i=6; i<12; i++)
			{
				sounds[i].Play(0, BufferPlayFlags.Looping);
				sounds[i].Volume = MIN_VOLUME;
			}

			for(int i=12; i<18; i++)
			{
				sounds[i].Stop();
			}

		}

		private void loadInsects()
		{
			inBirds = false;
			inAmphib = false;
			inInsects = true;

			pictureBox1.Image = Image.FromFile("field cricket.jpg");
			pictureBox2.Image = Image.FromFile("Acridid grasshopper.jpg");
			pictureBox3.Image = Image.FromFile("grasshopper-pallidwinged.jpg");
			pictureBox4.Image = Image.FromFile("redwingedgrasshopper.jpg");
			pictureBox5.Image = Image.FromFile("Cicada.jpg");
			pictureBox6.Image = Image.FromFile("tree cricket.jpg");

			labels[0] = "Field Cricket";
			labels[1] = "Acridid\nGrasshopper";
			labels[2] = "Pallidwinged\nGrasshopper";
			labels[3] = "Redwinged\nGrasshopper";
			labels[4] = "Cicada";
			labels[5] = "Tree Cricket";

			for(int i=0; i<12; i++)
			{
				sounds[i].Stop();
			}

			for(int i=12; i<18; i++)
			{
				sounds[i].Play(0, BufferPlayFlags.Looping);
				sounds[i].Volume = MIN_VOLUME;
			}
		}

		private void pictureBox3_Click(object sender, System.EventArgs e)
		{
		 
		}

		private void pictureBox5_Click(object sender, System.EventArgs e)
		{
		
		}

		private void pictureBox4_Click(object sender, System.EventArgs e)
		{
		
		}

		private void pictureBox6_Click(object sender, System.EventArgs e)
		{
		
		}

		private void pictureBox2_Click(object sender, System.EventArgs e)
		{
		
		}

		private void pictureBox1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.loadBirds();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.loadAmphib();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			this.loadInsects();
		}

	}
}
